Subject: [bug#39862] [PATCH v3 2/2] gnu: define dune-*-openmpi packages

From: Felix Gruber <[email-masked]>
Date: Fri, 13 Mar 2020 18:26:11 +0100

Hi Ludo’,

On 3/13/20 10:42 AM, Ludovic Courtès wrote:
> Felix Gruber <[email-masked]> skribis:
> 
>> * gnu/packages/maths.scm (dune-*-openmpi): New variables.
>> * gnu/packages/maths.scm (add-openmpi-to-dune-package): New function to
>>   add openmpi to the inputs of a dune-* package and replace all dune-*
>>   packages in its input with the corresponding dune-*-openmpi package.
> 
> Nitpick: no need to repeat the file name above.  It would also be great
> if you could list all the new variables.

Sure, no problem.

>> +      (lambda (p) (not (dune-package? p))))))
> 
> You can replace the lambda with:
> 
>   (negate dune-package?)

Thanks for this hint, as I'm new to Scheme, my knowledge of its standard
library is still pretty limited. The negate function is quite useful.

> One last thing: could you look at the output of, say, ‘guix graph
> dune-geometry-openmpi’ and ensure we’re not duplicating more nodes than
> needed in the graph?
> 
> For example, you can compare node counts with:
> 
>   guix graph dune-geometry | grep 'label =' | wc -l
>   guix graph dune-geometry-openmpi | grep 'label =' | wc -l
> 
> The difference should be less than:
> 
>   guix graph openmpi | grep 'label =' | wc -l
> 
> If that works well, please send an updated patch and we should be ready
> to go!

I get the following numbers:

 graph dune-geometry | grep 'label =' | wc -l
 70

 guix graph dune-geometry-openmpi | grep 'label =' | wc -l
 143

 guix graph openmpi | grep 'label =' | wc -l
 137

The difference seems to be OK: 143 - 70 = 73 < 137.

I'll send the updated patch ASAP.

Best Regards,
Felix